summaryrefslogtreecommitdiffstats
path: root/build-aux/get-vcs-id
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xbuild-aux/get-vcs-id49
1 files changed, 49 insertions, 0 deletions
diff --git a/build-aux/get-vcs-id b/build-aux/get-vcs-id
new file mode 100755
index 0000000..cca511a
--- /dev/null
+++ b/build-aux/get-vcs-id
@@ -0,0 +1,49 @@
+#!/bin/sh
+#
+# get-vcs-id
+#
+# Copyright © 2009-2024 Guillem Jover <guillem@debian.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+#
+
+error()
+{
+ echo "get-vcs-id: error: $*" 1>&2
+ exit 1
+}
+
+if [ -f .dist-vcs-id ]; then
+ # Get the VCS id from the file distributed in the tarball.
+ id="$(cat .dist-vcs-id)"
+elif [ -d .git ] || [ -f .git ]; then
+ if ! command -v git >/dev/null; then
+ error "cannot get project VCS id, git checkout but git program not found"
+ fi
+
+ # Get the VCS id from the git repository.
+ id="$(git rev-list -1 HEAD 2>/dev/null)"
+
+ # Check if we are on a dirty checkout.
+ git update-index --refresh -q >/dev/null
+ dirty=$(git diff-index --name-only HEAD 2>/dev/null)
+ if [ -n "$dirty" ]; then
+ id="$id-dirty"
+ fi
+else
+ error "cannot get project VCS id, not a git checkout nor a distribution tarball."
+fi
+
+# Use printf to avoid the trailing new line that m4_esyscmd would not handle.
+printf "%s" "$id"